Hibernate JPA 2 project template
================================

General:
--------
This project contains:

* `src/main/resources/META-INF/persistence.xml`<br/>
   Defining two persistence units both offering a JDBC database
   connection to a Mysql 5 server. You may want to adjust both
   database type and connection parameters.<br/>
   The first unit will re-create the database schema whereas using
   the second will preserve your current database schema.
 
* 
|Class         |Package               |Description           |
|--------------|----------------------|----------------------|
|`Airline`     |`$(packageroot).model`|JPA example entity    |
|`CreateEntity`|`$(packageroot)`      |Create database schema, persist an instance of Airline   |
|`SearchByIcao`|`$(packageroot)`      |JPA typesafe criteria search demo |
|`EntityTest`  |`$(testroot)`         |Persisting and re-reading an object by its primary key value |

* `src/main/resources/log4j2.xml` Configuring the log4j subsystem.

On executing i.e. »`mvn install`« Maven will 
[generate]
(https://docs.jboss.org/hibernate/orm/current/topical/html_single/metamodelgen/MetamodelGenerator.html)
metamodel classes like `Airline_.java` during the
»`generate-sources`« phase. These classes are being required for
[typesafe criteria based queries]
(http://docs.jboss.org/hibernate/entitymanager/3.6/reference/en/html/querycriteria.html#querycriteria-typedquery)
as being outlined in class `$(packageroot)`/`SearchByIcao`.

Eclipse IDE users:
------------------
On initial archetype based project generation your new project's
class »`SearchByIcao`« reveals a compile time error indicating a
missing class `Airline_`. Possible resolutions:

* Right click on your project's root choosing 
»`Run As`« ➩ »`Maven generate-sources`«

* Execute »`mvn generate-sources`« manually from the command line.

This step derives the missing metamodel class from `Airline`
thereby resolving the error.
When working with the Eclipse IDE (rather than with Maven directly)
this step is required whenever modifying your JPA data model.

IDE problems of this type are due to Eclipse's (and other IDE's)
limited Maven integration. The above workaroud triggers
the metamodel generator explicitely.
